var apiHost = {
	dev: 'http://sqjh.paiorder.com:8075',
	prod: 'https://apps.omygold.cn'
}
var env = {
	dev: {
		host: 'http://sqjh.paiorder.com:8075',
		packageKey: 'MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQ'
	},
	prod: {
		host: 'https://apps.omygold.cn',
		packageKey: 'hL8AXfHTvy+oy0Xs3CBqOPC3fwIDAQAB'
	}
}
var config = (function() {
	return env.prod;
})();


(function(win) {
	function getMac() {
		var mac = "xxx-xxx-xxx-xxx";
		return _mac = mac;
	}

	function getIp() {
		var ip = "127.0.0.1";
		return ip;
	}

	function intToIp(i) {
		return (i & 0xFF) + "." + ((i >> 8) & 0xFF) + "." + ((i >> 16) & 0xFF) + "." + ((i >> 24) & 0xFF);
	}

	var doc = win.document;
	var $ = window.$ || {};
	$.toAmount = function(val) {
		if ( typeof val !== 'undefined') {
			return (+val).toFixed(2);
		}
		return val;
	};
	$.getRondomStr = function(n) {
		var chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];

		function generateMixed(n) {
			var res = "";
			for (var i = 0; i < n; i++) {
				var id = Math.ceil(Math.random() * 35);
				res += chars[id];
			}
			return res;
		}

		return generateMixed(n);
	}
	$.getIp = getIp;
	$.getMac = getMac;
	$.get = function(url, data, callback) {
		if ( typeof data == 'function') {
			callback = data;
			data = null;
		}

		return this.request({
			url : url,
			data : data,
			method : 'get',
			onsuccess : callback
		});
	};
	$.post = function(url, data, callback) {
		if ( typeof data == 'function') {
			callback = data;
			data = null;
		}
		return this.request({
			url : url,
			data : data,
			method : 'post',
			onsuccess : callback
		});
	};

	$.obj2Str = function(obj) {
		if ( typeof obj == 'object') {
			var params = [];
			for (var key in obj) {
				if (obj.hasOwnProperty(key)) {
					params.push(key + '=' + encodeURIComponent(obj[key]));
				}
			}
			if (params.length) {
				obj = params.join('&');
			} else {
				obj = '';
			}
		}
		return obj;
	};

	$.loadPage = function(url, callback) {
		api.ajax({
			url : url,
			dataType : 'text'
		}, function(ret, err) {
			callback && callback(ret);
		});
	};
	$.showTip = function(dom) {
		var title = dom.getAttribute('title') || '';
		if (title) {
			var jq = $('<div style="position:fixed;top:0;left:0;right:0;bottom:0;background-color:rgba(255,255,255,0.5);text-align:center;"><div style="position:absolute;font-size:14px;left:15px;;right:15px;top:30%">' + '<div style="color:#666;padding:5px 10px;display:inline-block;border:1px solid #ccc;background-color:#fff;border-radius:4px;">' + title + '<div>' + '</div></div>');
			jq.appendTo('body');
			jq.on('touchstart', function() {
				$(this).remove();
			});
		}
	};
	$.request = function(options) {

		var method = (options.method || options.type || 'post').toLowerCase();
		options.data = $.extend({
			requestChannel : api.systemType.toLowerCase() == 'android' ? 2 : 3,
			systemOs : api.systemType.toLowerCase() == 'android' ? 'Android' : 'IOS',
			equipmentMac : getMac(),
			immeNo : api.deviceId,
			ip : getIp(),
			packageKey: config.packageKey
		}, options.data || {});
		var url = options.url;
		options.onerror = options.onerror || $.request.onerror;
		// options.headers = $.extend(options.headers, {cookie : storedCookie});
		console.log('url=>' + url);
		console.log('params:' + JSON.stringify(options.data));

		var path = api.cacheDir + '/cookie.txt';
		api.readFile({
			path: path
		}, function(ret) {
			var storedCookie = ret.data;
			// alert(options.url + '=> cookie: ' +storedCookie);
			console.log('_cookie=>' + storedCookie);
			if (storedCookie) {
				document.cookie = storedCookie;
			}
			var headers = $.extend({
				cookie : storedCookie,
				isAjax: true
			}, options.headers);
			console.log('headers==========='+JSON.stringify(headers));
			//.getItem('_cookie') || '';
			api.ajax({
				url : url.indexOf('://') == -1 ? (config.host + url) : url,
				method : method,
				dataType : options.dataType || 'json',
				returnAll : true,
				headers : headers,
				data : {
					values : options.data
				}
			}, function(ret, err) {
				console.log('ajax:response url => ' + (config.host + options.url));
				console.log('ajax:response start ==================================');
				if (typeof ret === 'object') {
					console.log('ajax:response success => ' + JSON.stringify(ret));
				}
				if (typeof err === 'object') {
					console.log('ajax:response error => ' + JSON.stringify(err));
				}
				$.unloading();
				if (!ret) {
					mui.toast(err.msg);
					return;
				}
				var cookie = ret.headers['Set-Cookie'];
				if (cookie) {
					var start;
					if (( start = cookie.indexOf('jc-jsessionid=')) != -1) {// has cookie
						var end = cookie.indexOf(';');
						if (end == -1) {
							end = cookie.length;
						}
						cookie = cookie.substr(0, end);
						if (cookie) {
							if (cookie != storedCookie) {
								storedCookie = cookie;
								api.writeFile({
									path: path,
									data: storedCookie
								});
								console.log('set_cookie:' + cookie);
							}
						}
					}
				} else {
					api.setPrefs({
						key : '_cookie',
						value : storedCookie
					});
				}

				ret = ret.body;
				if (method == 'post' && url != '/token') {
					$.getToken();
				}
				if (ret) {
					var code = ret.code;
					console.log(code);
					if (code != 200) {
						if (code == 202 || code == 510) { // has no login
							// alert(options.url);
							localStorage.removeItem('is_logined');
							api.removePrefs({
								key : '_cookie'
							});
							if (location.href.indexOf('frame1.html') != -1) {
								// alert('mylogin');
								location.href = 'my_login.htm';
							} else {
								// alert('check appStarting: ' + localStorage.getItem('appStarting'));
								if (localStorage.getItem('appStarting')) {
									// alert('appStarting');
									localStorage.setItem('toLoginOnAppStartEnd', true);
									return;
								} else {
									// alert('showLogin');
									$.openNewWin('login.htm', '登录');
								}
							}
							return;
						}
						if (options.failCallBack) {
							options.failCallBack && options.failCallBack(ret);
						} else {
							options.onerror && options.onerror(ret);
						}
					} else {
						if (options.successCallBack) {
							options.successCallBack && options.successCallBack(ret);
						} else {
							options.onsuccess && options.onsuccess(ret);
						}
					}
				} else {
					api.toast({
						msg : err.msg
					});
				}
				console.log('ajax:response end ====================================');
			});
		});
	};

	$.request.onerror = function(ret) {
		mui.toast(ret.msg || '操作失败');
	};

	if ($.fn) {
		$.fn.getFormJson = function(exceptNames) {
			var resultObj = {};
			$(this).find('input[name],textarea[name]').each(function() {
				if (resultObj[this.name] !== undefined) {
					if (!resultObj[this.name].push) {
						resultObj[this.name] = [resultObj[this.name]];
					}
					resultObj[this.name].push(this.value || '');
				} else {
					resultObj[this.name] = this.value || '';
				}
			});
			if (exceptNames && exceptNames.length > 0) {
				$.each(exceptNames, function(index, exceptName) {
					$.each(resultObj, function(name, val) {
						if (exceptName == name) {
							delete resultObj[exceptName];
						}
					});
				});
			}
			return resultObj;
		};
	}
	$.commonTip = function(msg) {
		if (!msg || $('#tipMask').is(":visible")) {
			return;
		} else {
			$('#commonTip').text(msg);
			$('#tipMask').show();
			setTimeout(function() {
				$('#tipMask').hide();
			}, 2500);
		}
	};

	$.openNewWin = function(url, title, canBack, hasRightIcon, pageParam, slidBackEnabled) {
		canBack = ( typeof canBack == 'undefined' ? true : canBack);
		//title, url, null, canBack, {}, hasRightIcon

		$.newWin(title, {
			url : url,
			name : url.split('.')[0],
			slidBackEnabled: slidBackEnabled,
			canBack : canBack,
			hasRightIcon : hasRightIcon,
			pageParam : pageParam
		});
	};
	$.newWin = function(title, options) {
		if ( typeof options == 'string') {
			options = {
				name : options,
				url : options
			};
		}

		if(!window.api){
			return;
		}
		var name = 'p_' + (options.name || options.url);
		console.log('name:==============:   '+name);
		api.openWin({
			name : name,
			url : 'common.html',
			slidBackEnabled: options.slidBackEnabled === false ? false : true,
			pageParam : {
				title : title,
				url : options.url,
				name : options.name || options.url,
				canBack : options.canBack === false ? false : true,
				hasRightIcon : options.hasRightIcon ? true : false,
				pageParam : options.pageParam || {}
			}
		});
	};

	$.loading = function() {
		api.showProgress({});
	};
	$.unloading = $.unLoading = function() {
		api.hideProgress();
	};

	$.closeToHome = function() {
		api.closeToWin({
			name : 'root'
		});
	};

	$.setValidImgCode = function(img,callback) {
		var url = config.host + "/simpleCaptcha.png?_=" + (new Date() / 100);

		var xhr = new XMLHttpRequest();
		xhr.open('GET', url, true);
		xhr.responseType = "blob";
		//xhr.responseType = "json";
		var storedCookie = api.getPrefs({
			sync : true,
			key : '_cookie'
		});
		console.log('img _cookie=>' + storedCookie);
		if (storedCookie) {
			try {
				xhr.setRequestHeader("cookie", storedCookie);
			} catch (e) {
				console.log(e);
			} finally {
				console.log();
			}
		}
		xhr.onload = function() {
			if (this.status == 200) {
				// var blob = this.response;
				// var urlObj = window.URL || window.webkitURL;
				// img.onload = function(e) {
				// 	urlObj.revokeObjectURL(img.src);
				// };
				// img.src = urlObj.createObjectURL(blob);
				var blob = this.response;
				var urlObj = window.URL || window.webkitURL;
				img.onload = function(e) {
					urlObj.revokeObjectURL(img.src);
				};
				img.src = "http://scimg.jb51.net/allimg/160308/14-16030Q504160-L.jpg";
				var cookie = xhr.getResponseHeader('Set-Cookie');
				if (cookie) {
					var start;
					if (( start = cookie.indexOf('jc-jsessionid=')) != -1) {// has cookie
						var end = cookie.indexOf(';');
						if (end == -1) {
							end = cookie.length;
						}
						cookie = cookie.substr(0, end);
						if (cookie) {
							if (cookie != storedCookie) {
								storedCookie = cookie;
								api.setPrefs({
									key : '_cookie',
									value : storedCookie
								});
								console.log('set_cookie:' + cookie);
							}
						}
					}
				}
				callback && callback();
			}
			alert("execute step 4");
		}
		alert("execute step 5");
		xhr.send();
		alert("execute step 6");
	};

	$.getToken = function(target, callback) {
		if (!window.$ || typeof window.$ !== 'function') {
			return;
		}
		target = target ? $(target) : $('[name="form_token"]');
		if ($(target).length == 0) {
			return;
		}
		$.request({
			url : "/token",
			type : "GET",
			onsuccess : function(ret) {
				target.val(ret.data);
				callback && callback(ret.data);
			}
		});
	};

	$.getSearchParam = function(url, name) {
		var pos = url.indexOf('?');
		var rt = {};
		if (pos) {
			var search = url.substr(pos + 1);
			var params = search.split('&');
			for (var i = 0, l = params.length; i < l; i++) {
				var str = params[i];
				var parts = str.split('=');
				rt[parts[0]] = parts[1] || '';
			}
		}
		if (name) {
			return rt[name] || '';
		}
		return rt;
	};

	$.render = function(tpl, data) {
		if (!tpl || !data) {
			return;
		}
		return $.template($.replaceSign(tpl), data);
	};

	$.template = function(str, data) {
		var _formatJson_cache = {};
		var code = "var p=[],print=function(){p.push.apply(p,arguments);};" + "with(obj){p.push('" + str.replace(/[\r\t\n]/g, " ").split("<%").join("\t").replace(/((^|%>)[^\t]*)'/g, "$1\r").replace(/\t=(.*?)%>/g, "',$1,'").split("\t").join("');").split("%>").join("p.push('").split("\r").join("\\'") + "');}return p.join('');";
		var fn = _formatJson_cache[str] || new Function("obj", code);
		return data ? fn(data) : fn;
	};

	$.replaceSign = function(str) {
		return str.replace(/<js\s+/g, "<%").replace(/\/js>/g, "%>");
	};
	// 计算浮点数乘积
	$.mulAmount = function(arg1, arg2) {
		var m = 0, s1 = arg1.toString(), s2 = arg2.toString();
		try {
			m += s1.split(".")[1].length
		} catch (e) {
		}
		try {
			m += s2.split(".")[1].length
		} catch (e) {
		}
		return (Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m)).toFixed(2);
	};

	// 计算浮点数之和
	$.sumAmount = function(arg1, arg2) {
		var r1, r2, m;
		try {
			r1 = arg1.toString().split(".")[1].length
		} catch (e) {
			r1 = 0
		}
		try {
			r2 = arg2.toString().split(".")[1].length
		} catch (e) {
			r2 = 0
		}
		m = Math.pow(10, Math.max(r1, r2))
		return ((arg1 * m + arg2 * m) / m).toFixed(2);
	};

	$.loadJs = function(url) {
		var script = document.createElement("script");
		script.type = "text/javascript";
		script.src = url;
		document.getElementsByTagName('head')[0].appendChild(script);
	};
	var class2type = {};
	"Boolean Number String Function Array Date RegExp Object Error".split(" ").map(function(name, i) {
		class2type["[object " + name + "]"] = name.toLowerCase();
	});
	$.type = function(obj) {
		if (obj == null) {
			return obj + "";
		}
		return typeof obj === "object" || typeof obj === "function" ? class2type[toString.call(obj)] || "object" : typeof obj;
	};

	// document.addEventListener('touchstart',function(evt){
	//
	// },false);
	//
	// document.addEventListener('touchstart',function(evt){
	//
	// },false);

	$.valiBlank = function(val, msg) {
		var result = true;
		if (val === "" || val == undefined) {
			mui.toast(msg || "请输入该项");
			result = false;
		}
		return result;
	};
	$.valiMobile = function(val) {
		var result = true;
		result = $.valiBlank(val, "请输入手机号码");

		// if (result && !/^(13|15|18|14|17)[0-9]{9}$/.test(val)) {
		if (result && !/^(1)[0-9]{10}$/.test(val)) {
			mui.toast("请输入正确格式的手机号码");
			result = false;
		}
		return result;
	};
	$.valiAccount = function(val) {
		var result = true;
		result = $.valiBlank(val, "请输入账号");
		// if (result && !/^(13|15|18|14|17)[0-9]{9}$/.test(val)) {
		if (result && !/^(1)[0-9]{10}$/.test(val)) {
			mui.toast("请输入正确格式的账号");
			result = false;
		}
		return result;
	};
	$.valiWeight = function(val, msg) {
		var result = true;
		if (isNaN(val)) {
			result = false;
		} else if (val < 0.01) {
			result = false;
		} else if(val > 9999.99) {
			result = false;
		}else {
			result = true;
		}
		if (!result) {
			mui.toast(msg || "购买克数应大于等于0.01g小于等于9999.99g");
		}
		return result;
	};
	$.valiMoney = function(val, msg) {
		var result, exp;
		exp = /^(([1-9][0-9]*)|(([0]\.\d{1,2}|[1-9][0-9]*\.\d{1,2})))$/;
		if (isNaN(val)) {
			result = false;
		} else if (val == 0) {
			result = false;
		} else if (!exp.test(val)) {
			result = false;
		} else {
			result = true;
		}
		if (!result) {
			mui.toast(msg || "金额应该是大于0保留两位小数的数字");
		}
		return result;
	};
	$.valiIdentityNo = function(val, msg) {
		var result = true, reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
		if (reg.test(val) === false) {
			mui.toast(msg || "身份证号码格式不正确");
			result = false;
		}
		return result;
	};
	$.valiLoginPwd = function(val, msg) {
		var result = true;
		result = $.valiBlank(val, "请输入密码");
		if (result && val.length < 6) {
			mui.toast("密码长度必须大于等于6位");
			result = false;
		}
		return result;
	};
	$.toast = function(msg) {
		api.toast({
			msg : msg
		});
	};

	$.alert = function(msg, callback) {
		api.alert({
			msg : msg
		}, function(ret, err) {
			//coding...
			callback && callback();
		});
	};
	$.valiPayPwd = function(val, msg) {
		var result = true;
		result = $.valiBlank(val, "请输入支付密码");
		if (result && val.length < 6) {
			mui.toast("支付密码长度必须大于等于6位");
			result = false;
		}
		return result;
	};
	$.valiBankAccount = function(val, msg) {
		var result = true;
		if (isNaN(val)) {
			result = false;
		} else if (val == 0) {
			result = false;
		} else if (!(parseInt(val) == val && parseInt(val) > 0)) {
			result = false;
		} else if (val.length <= 10) {
			result = false;
		} else {
			result = true;
		}
		if (!result) {
			mui.toast(msg || "银行卡号格式不正确");
		}
		return result;
	};
	win.$ = $;
	win.getParam = function(name) {
		return $.getSearchParam(location.href, name);
	};
	$.plusReady = function(func) {
		win.apiready = func;
	};
	var c = {};
	c.each = function(items, func) {
		if (!func) {
			return;
		}
		$.each(items, function(idx, item) {
			return func(item, idx);
		});
	};

	var setDownRefreshDefaults = {
		visible : true,
		loadingImg : 'widget://image/loading_more.gif',
		bgColor : '#eee',
		textColor : '#999',
		textDown : '下拉刷新...',
		textUp : '松开刷新...',
		showTime : true
	};
	c.setDownRefresh = function(callback, options) {
		api.setRefreshHeaderInfo($.extend(options || {}, setDownRefreshDefaults), function(ret, err) {
			isUpRefreshing = false;
			if (upRefeshLoader) {
				upRefeshLoader.text('');
			}
			callback && callback();
		});
		return this;
	};
	c.startDownRefresh = function() {
		api.refreshHeaderLoading();
		return this;
	};
	c.endDownRefresh = function() {
		api.refreshHeaderLoadDone();
		return this;
	};
	var isUpRefreshing = false, upRefeshLoader = null;
	c.setUpRefresh = function(callback, container) {
		if (container && typeof container == 'string') {
			container = document.getElementById(container);
		}
		upRefeshLoader = $('<div class="loading"></div>').appendTo(container || 'body');
		api.addEventListener({
			name : 'scrolltobottom',
			extra : {
				threshold : 0 //设置距离底部多少距离时触发，默认值为0，数字类型
			}
		}, function(ret, err) {
			if (isUpRefreshing) {
				return;
			}
			isUpRefreshing = true;
			upRefeshLoader.addClass('loading_more');
			callback && callback();
		});
		return this;
	};
	c.endUpRefresh = function() {
		isUpRefreshing = false;
		upRefeshLoader.removeClass('loading_more');
		return this;
	};
	c.noMoreData = function() {
		upRefeshLoader.removeClass('loading_more').text('没有更多了...');
		isUpRefreshing = true;
	};

	c.filter = function(arr, func) {
		return arr.filter(func);
	};
	c.slice = function(arr, start, end) {
		return arr.slice(start, end);
	};
	c.doubleNum = function(v) {
		return v > 9 ? v : ('0' + v);
	};
	var Moment = function(timestamp) {
		this.timestamp = timestamp;
		this.date = new Date(timestamp);
	};
	Moment.prototype.format = function(formatStr) {
		if (formatStr == 'YYYY-MM-DD HH:mm:ss') {
			var year = this.date.getFullYear();
			var month = this.date.getMonth() + 1;
			var date = this.date.getDate();
			var hour = this.date.getHours();
			var minute = this.date.getMinutes();
			var second = this.date.getSeconds();
			return year + '-' + month + '-' + date + ' ' + c.doubleNum(hour) + ':' + c.doubleNum(minute) + ':' + c.doubleNum(second);
		}
		return this.timestamp;
	};

	Moment.prototype.day = function() {
		return this.date.getDay();
	};

	win.moment = function(datetime) {
		return new Moment(datetime);
	};
	c.concat = function(arr) {
		return arr.concat.call(arr, Array.prototype.slice.call(arguments, 1));
	};
	win._ = c;
	win.mui = $;
})(window);

function showWin(dom, href, title) {
	if (!title) {
		title = dom.getAttribute('title') || dom.innerText.trim() || '';
	}
	if (!~href.indexOf('.')) {//
		href = href + '.htm';
	}
	$.newWin(title, {
		url : href,
		name : href.split('.')[0]
	});
}
