(function() {
	mui.plusReady(function() {
		var mainForm, captchaUrl;

		captchaUrl = config.host;

		var main = function() {
			mainForm = $('#mainForm');
			document.getElementById('captchaImg').style.visibility = 'visible';
			window.bindEvent.captchaImg();
		};

		window.bindEvent = {
			captchaImg:function(dom,callback){
				document.getElementById('captchaImg').setAttribute('src', captchaUrl+'/simpleCaptcha.png?_='+new Date().getTime());
			},
			submit:function(){
			var data = mainForm.getFormJson();
				if(!$.valiMobile(data.mobile)) {
					return;
				}
				if(!$.valiBlank(data.captcha, "请输入验证码")) {
					return;
				}
				$.loading();
				$.request({
					url: "/security/reset_pwd/step1",
					data: data,
					successCallBack: function(response) {
						$.openNewWin('find_pwd_step2.htm?mobile='+data.mobile,'找回密码');
					},
					onerror: function(response) {
						bindEvent.captchaImg();
						mui.toast(response.msg || '操作失败');
						$('[name="captcha"]').val('');
						$('#captchaImg').trigger('tap');
					}
				});
			}
		};

		main();
	});
})();
