mui.plusReady(function () {
  var mainForm;
  var main = function () {
    mainForm = $('#mainForm');
    $.getToken();
  };

  window.bindEvent = {
    submit: function () {
      var data = mainForm.getFormJson();

      if (!$.valiBlank(data.realName, "请输入姓名")) {
        return;
      }
      if (!$.valiBlank(data.identityCardNo, "请输入身份证号")) {
        return;
      }
      if (!$.valiIdentityNo(data.identityCardNo)) {
        return;
      }
      $.loading();
      $.request({
				url: "/member/modify",
				data: data,
				successCallBack: function (response) {
					if (response.code == "200") {
            $.request({
              type: "GET",
              url: "/member/query",
              onsuccess: function (response) {
                var user = response.data;
                if (user) {
                  mui.toast('实名认证成功');
                  localStorage.setItem('user', JSON.stringify(response.data));
                  api.execScript({
                    name: 'p_setting',
                    frameName: 'setting',
                    script: 'window.initData()'
                  });
                  api.sendEvent({
                    name: 'reloadMessageCount',
                  });
                  api.closeWin({name: 'p_identity'});
                }
              }
            });
					} else {
						alert(response.msg || '系统错误');
					}
				},
				onerror: function (response) {
					alert(response.msg || '系统错误');
				}
			});
    }
  };

  main();
});
