mui.plusReady(function() {
	var items = [];
	var main = function() {
		if($.complete_user_action == "0") {
			return;
		}
		$api.fixStatusBar($api.dom('#top_img'));
		api.setStatusBarStyle({
			style : 'dark',
			color : '#f37202'
		});

		initData(function() {
			_.setDownRefresh(function() {
				initData(function() {
					_.endDownRefresh();
				});
			});
		});

		api.addEventListener({
			name : 'logoff'
		}, function(ret, err) {
			//coding...
			localStorage.removeItem('is_logined');
			location.href = 'my_login.htm';

		});

		showShare();
	};

	function showShare() {
		if(api.systemType.toLowerCase() == 'ios') {
			var wx = api.require('wx');
			wx.isInstalled(function(ret, err) {if (ret.installed) {
				$('#shareUl').show();
				items.push({
					text: '微信',
					icon: 'widget://img/share_weixin.png'
				});						
			}});
			
			var qq = api.require('qq');
			qq.installed(function(ret, err) {if (ret.status) {
				$('#shareUl').show();	
				items.push({
					text: 'QQ',
					icon: 'widget://img/share_qq.png'
				});				
			}});
			
			var weibo = api.require('weibo');
			weibo.isInstalled(function(ret, err) {if (ret.status) {
				$('#shareUl').show();	
				items.push({
					text: '微博',
					icon: 'widget://img/share_weibo.png'
				});					
			}});
		}else {
			$('#shareUl').show();
			items.push(
				{
					text: '微信',
					icon: 'widget://img/share_weixin.png'
				},
				{
					text: 'QQ',
					icon: 'widget://img/share_qq.png'
				},
				{
					text: '微博',
					icon: 'widget://img/share_weibo.png'
				}
			);			
		}
	}

	var initData = function(callback) {
		$.request({
			type : "GET",
			url : "/member/query",
			onsuccess : function(response) {
				localStorage.setItem('is_logined', '1');
				var user = response.data;
				if (user) {
					localStorage.setItem('user', JSON.stringify(response.data));
					$('#username').html((user.realName ||  '') + '<div>' + (user.mobile||"") + '</div>');
					if (user.unreadMessageCount) {
						$('.user-manager .point').css({display: 'block'});
						api.sendEvent(
							{
								name: 'reviceUnreadMessageCount',
								extra: {
									count: user.unreadMessageCount,
								}
							}
						)
					}
					$.request({
						type : "GET",
						url : "/index/gold_price",
						successCallBack : function(response) {
							callback && callback();
							if (response.data.code === 800) {
								// $.openNewWin('choose_third_login_action.htm', '成为金持会员');
								$.newWin('成为金持会员', {
									url : 'choose_third_login_action.htm?action=all', 
									name : 'choose_third_login_action',
									slidBackEnabled: false,
								});
								return;
							}
							localStorage.setItem('gold_price', JSON.stringify(response.data));
							gold_price = response.data;
							if(!isNaN(user.totalWeight) && !isNaN(gold_price.publicPrice)) {
								var msg = '<b>' + $.toAmount($.mulAmount((user.totalWeight+user.frozeWeight), gold_price.publicPrice)) + '</b></br><span>（' + user.totalWeight + ' + ' + user.frozeWeight + '） 克 x ' + gold_price.publicPrice + ' 元/克 </span>';
								$('#user-level').html(msg);
								var msg2 = '<div><span><strong>'+ user.totalWeight + '</strong>克</span>已有克重</div>' + '<div><span><strong>'+ user.frozeWeight + '</strong>克</span>回收中</div>';
								$('#gold-detail').html(msg2);
							}

							if(user.completeFlag == "0") {
								// $.openNewWin('choose_third_login_action.htm', '成为金持会员');
								$.newWin('成为金持会员', {
									url : 'choose_third_login_action.htm?action=all', 
									name : 'choose_third_login_action',
									slidBackEnabled: false,
								});
								_.endDownRefresh();
								_.setDownRefresh(function() {
									initData(function() {
										_.endDownRefresh();
									});
								});
								return;
							}
						}
					});
				}
			},
			onerror : function() {
				location.href = 'p_my_login.htm';
			}
		});
	};

	window.bindEvent = {
		setting : function() {
			$.openNewWin('setting.htm', '账号设置');
		},
		share : function() {
			var dialogBox = api.require('dialogBox');
			
			dialogBox.actionMenu ({
				tapClose: true,
		    rect:{
		      h: 160
		    },
		    texts:{
		      cancel: '取 消'
		    },
		    items:items,
		    styles:{
	        bg:'#FFF',
	        column: 3,
	        itemText: {
            color: '#000',
            size: 12,
            marginT:8
	        },
	        itemIcon:{
            size:45
	        },
	        cancel:{
            bg: 'fs://icon.png',
            color:'#000',
            h: 44 ,
            size: 16
	        }
		    }
			}, function(ret){
				var dialogBox = api.require('dialogBox');
				dialogBox.close({dialogName: 'actionMenu'});		
				if(ret.eventType == 'click') {

					// 微信分享
					if(ret.index == "0") {
						weixinShare();

					// QQ分享
					}else if(ret.index == "1") {
						qqShare();

					// 微博分享
					}else if(ret.index == "2") {
						weiboShare();
					}
				}
			});
		}
	};

	var weixinShare = function(btnIndex) {
		var wx = api.require("wx");
		wx.isInstalled(function(ret, err) {
			if (ret.installed) {
				$.loading();
				$.request({
					url: "/auth_login/param/query",
					data: {
						platform: "weixin"
					},
					successCallBack: function(ret) {
						wx.shareWebpage({
		          apiKey: ret.data.appId,
		          scene: 'session',
							title: '金持',
							description: '金持 - 持金有道',
							thumb: 'widget://imgages//big_logo2.jpg',
		          contentUrl: 'http://a.app.qq.com/o/simple.jsp?pkgname=omygold.com'
		        }, function(ret, err){
		          if(ret.status){
		            alert('分享成功');
		          }else{

		            //-1（未知错误）
		            //0（成功）
		            //1（apiKey非法）
		            //2（用户取消）
		            //3（发送失败）
		            //4（授权拒绝）
		            //5（微信服务器返回的不支持错误）
		            //7 (注册SDK失败)		            
								alert('分享失败');								
		          }
		        });
					},
					failCallBack: function () {
						flag = false;
					}
				});
	    } else {
	      alert('当前设备未安装微信客户端');
	    }
		});
	};

	var qqShare = function(btnIndex) {
		var qq = api.require("qq");
		qq.installed(function(ret, err) {
			if (ret.status) {
				qq.shareText({text: 'http://a.app.qq.com/o/simple.jsp?pkgname=omygold.com'});
	    } else {
	      alert('当前设备未安装QQ');
	    }
		});
	};

	var weiboShare = function(btnIndex) {
		var weibo = api.require("weibo");
		weibo.isInstalled(function(ret, err) {
			if (ret.status) {
				var weibo = api.require('weibo');
				weibo.shareImage({
			    text: '金持 - 持金有道' + 'http://a.app.qq.com/o/simple.jsp?pkgname=omygold.com',
			    imageUrl: 'widget://images/qqq.jpg'
				}, function(ret, err) {
			    if(ret.status){
            alert('分享成功');
          }else{

            //错误码：
						//-1 （ apiKey 值非法）
						//1 （用户取消）
						//2 （发送失败）
						//3 （授权失败）
						//4 （不支持的请求）
						//5 （未知错误）            
						alert('分享失败');						
					}
				});	
	    } else {
	      alert('当前设备未安装微信客户端');
	    }
		});
	};
	main();
});
