(function() {
	mui.plusReady(function() {
		var mainForm, pageSize, pageNo, total,sortType='',sortValue='',keywords='';

		_.setDownRefresh(function() {
			pageNo = 1;
			pageSize = 10;
			total = 1;
			queryRecords(function() {
				_.endDownRefresh();
			});
		}).setUpRefresh(function() {
			queryRecords(function() {
				_.endUpRefresh();
			});
		}, document.getElementById('content'));

		var main = function() {
			pageNo = 1;
			pageSize = 10;
			total = 1;
			mainForm = $('#mainForm');
			initData();
		};

		var initData = function() {
			$.loading();
			queryRecords();
		};

		var queryRecords = function(callback) {

			$.request({
				url : "/index/product/list",
				data : {
					pageSize : pageSize,
					pageNo : pageNo,
					sortValue:sortValue,
					sortType:sortType,
					keywords:keywords
				},
				successCallBack : function(response) {
					callback && callback();
					if (response && response.data && response.data.data) {
						if (total < pageNo) {
							_.noMoreData();
							return;
						}
						if (pageNo == 1) {
							$('#exchangesProductsUl').children().remove();
						}
						$('#exchangesProductsUl').append($.render($('#exchangesProductsTpl').html(), response.data.data));
						api.parseTapmode();
						total = response.data.total;
						pageNo++;

					} else {
						mui.toast('查询产品信息失败！');
					}
				}
			});
		};
		var sortFunc = function(dom) {
			mainForm.find('[sortType]').removeClass('sort-active');
			$(dom).addClass('sort-active');
			mainForm.find('[name="sortType"]').val($(dom).attr('sortType'));
			mainForm.find('[name="sortValue"]').val($(dom).find('span').hasClass('up') ? 0 : 1);
			//				if($(this).attr('id') == 'priceNum') {
			//					var sortValue = $(this).attr('sortValue') == '1' ? '0' : '1';
			//					$(this).attr(sortValue);
			//				}
			$(dom).find('span').toggleClass('up');

		};
		window.sortFunc = function(_sortType,_sortValue) {
			sortType = _sortType;
			sortValue = _sortValue;
			pageNo = 1;
			total = 1;
			queryRecords();
		};
		window.search =  function(key){
			$.loading();
			keywords = key;
			pageNo = 1;
			total = 1;
			queryRecords();
		};
		window.bindEvent = {
			onlineExchange : function(dom) {
				var productId = $(dom).attr('productId');
				var data = {
					productId : $(dom).attr('productId'),
					productName : $(dom).attr('productName'),
					sku : $(dom).attr('sku'),
					productAmount : $(dom).attr('productAmount')
				};
				// $.loading();
				api.openWin({
					name : 'product_detail_wrapper',
					url : 'product_detail_wrapper.html',
					pageParam : {
						productId : productId
					}
				});
				// $.request({
				// 	url : "/order/online_consume/pre_create",
				// 	data : data,
				// 	successCallBack : function(response) {
				// 		$.openNewWin('online_exchange_step1.htm?orderNo=' + response.data.orderNo, '线上提货');
				// 	}
				// });
			},
			viewNum : sortFunc

		};

		main();
	});
})();


