(function() {
	mui.plusReady(function() {
		var main = function() {
			initData();
		};

		var initData = function() {
			$.loading();
			$.request({
				type: "GET",
				url: "/member/query",
				successCallBack: function(response) {
					$.unLoading();
					localStorage.setItem('user', JSON.stringify(response.data));
					user = JSON.parse(localStorage.getItem('user'));
					$('img.qrcode').attr('src', (user.inviteBarCodeUrl || 'images/unknown.jpg'));
					$('#code-img').show();
					if(!user.inviteBarCodeUrl) {
						$('#no-info').show();
					}
				},
				businessFailCallBack: function(response) {
					$.unLoading();
					$('img.qrcode').attr('src', (user.inviteBarCodeUrl || 'images/unknown.jpg'));
					mui.toast(response.msg || "获取用户信息失败");
					if(!user.inviteBarCodeUrl) {
						$('#no-info').show();
					}
				}
			});
		};
		main();
	});
})();
