(function() {
	mui.plusReady(function() {
		var pageSize, pageNo, isLoading, total, pageNo2, total2;
		_.setDownRefresh(function() {
				pageNo = 1;
				pageSize = 10;
				total = 1;

				pageNo2 = 1;
				pageSize2 = 10;
				total2 = 1;
				queryRecords(function() {
					_.endDownRefresh();
				});
			}).setUpRefresh(function() {
				queryRecords(function() {
					_.endUpRefresh();
				});
			},document.getElementById('main').parentElement);
		var main = function() {
			pageNo = 1;
			pageSize = 5;
			total = 1;

			pageNo2 = 1;
			pageSize2 = 10;
			total2 = 1;
		
			$.loading();
			queryRecords();
		};

		function queryRecords(callback) {

			$.request({
				type : "GET",
				url : "/order/redeem/list",
				data : {
					pageSize : pageSize,
					pageNo : pageNo
				},
				successCallBack : function(response) {
					callback && callback();
					if (response && response.data && response.data.data) {

						if (pageNo == 1) {
							$('#main').html($.render($('#recordsTpl').html(), response.data.data));
							if(response.data.data.length == "0") {
								queryProducts();
							}
						} else {

							if (response.data.data.length) {
								$('#main').append($.render($('#recordsTpl').html(), response.data.data));
							} else {
								mui.toast('没有更多了');
								return;
							}
						}

						pageNo++;

						total = response.data.total;
					} else {
						mui.toast('查询失败！');
					}
				}
			});
		};

		function queryProducts() {
			if (pageNo2 > total2) {
				mui.toast('没有更多了');
				return;
			}
	
			$.request({
				url : "/index/product/list",
				data : {
					pageSize : pageSize2,
					pageNo : pageNo2
				},
				successCallBack : function(response) {
					if (response && response.data && response.data.data) {
						$('#detailProductsUl').append($.render($('#detailProductsTpl').html(), response.data.data));
						api.parseTapmode();
						total2 = response.data.total;
						pageNo2++;
					} else {
						mui.alert('查询产品信息失败！');
					}
				}
			});
		}
		window.bindEvent = {
			productDetail: function (productId) {     	 		   
				api.openWin({
					name: 'product_detail_wrapper'+productId,
					url: 'product_detail_wrapper.html',
					pageParam:{
						productId:productId
					}
				});
			},
			cancel_redeem : function(dom) {
				var btnArray = ['否', '是'], orderNo = $(dom).attr('orderNo');
				api.confirm({
					title : '确认',
					msg : '确认取消吗？',
					buttons : btnArray
				}, function(ret, err) {
					if (ret.buttonIndex == 2) {
						$.post('/order/redeem/cancel', {
							orderNo : orderNo
						}, function(response) {
							if (response && response.code == '200') {
								mui.toast(response.msg || '操作成功');
								pageNo = 1;
								total = 1;
								queryRecords();
							} else {
								mui.toast(response.msg || '操作失败');
							}
						});
					}
				});				 
			},
			redeem:function(dom){
				$.openNewWin("redeem_step2.htm?orderNo=" + $(dom).attr('orderNo'), "确认回收");
			}
		};
		 
		main();
	});
})();
