mui.plusReady(function() {
	var mainForm, mobile, intervalId;

	var main = function() {
		mainForm = $('#mainForm');
		mobile = getParam('mobile');
		$.getToken();

	};

	var countSeconds = function() {
		var count = 60;
		$('#sendCode').text('重新发送(' + (count--) + ')');
		clearInterval(intervalId);
		intervalId = null;
		$('#sendCode').attr('disabled', true);

		intervalId = setInterval(function() {
			if (count == 0) {
				clearInterval(intervalId);
				intervalId = null;
				$('#sendCode').text('重新发送');
				$('#sendCode').removeAttr('disabled');
			} else {
				$('#sendCode').text('重新发送(' + (count--) + ')');
			}
		}, 1000);
	};
	window.bindEvent = {
		sendCode : function() {
			if ($('#sendCode').attr('disabled')) {
				return;
			}
			$('#sendCode').attr('disabled', true);
			$.request({
				url : "/security/register/send_mobile_captcha",
				data : {
					mobile : mobile,
					form_token:$('[name="form_token"]').val()
				},
				successCallBack : function(response) {
					if (response.code == "200") {
						mui.alert('验证码已经发送到您的手机' + (mobile.slice(0, 3)) + '***' + (mobile.slice(7, 11)));
						countSeconds();
					} else {
						mui.alert(response.msg || '发送失败，请重新发送。');
						$('#sendCode').removeAttr('disabled');
					}
				},
				failCallBack : function(textStatus) {
					if (textStatus != 'canceled') {
						mui.alert('发送失败，请重新发送。');
						$('#sendCode').removeAttr('disabled');
					}
				}
			});
			$.getToken();
		},
		mobileCaptcha : function() {//keyup
			if ($('[name="mobileCaptcha"]').val()) {
				$('[role="submit"]').attr('disabled', false);
			} else {
				$('[role="submit"]').attr('disabled', true);
			}
		},
		submit : function() {
			// 获取form数据
			var data = $.extend(mainForm.getFormJson(), {
				mobile : mobile
			});
			$.loading();
			// 提交表单
			$.request({
				url : "/security/member/register/step2",
				data : data,
				successCallBack : function(response) {
					$.openNewWin('operate_success_wrapper.html?action=register', '注册成功', false);
				}
			});
		}
	};

	$('[name="mobileCaptcha"]').on('keyup', function(e) {
			e.preventDefault();
			if ($('[name="mobileCaptcha"]').val()) {
				$('[role="submit"]').removeAttr('disabled');
			} else {
				$('[role="submit"]').attr('disabled', true);
			}
	});
	main();
});
