(function () {
	mui.plusReady(function () {
		console.log('setting loading');
		var user;
		var main = function () {
			initData();
		};

		window.bindEvent = {
			logoff: function () {
				api.confirm({
					title: '提示',
					msg: '确定退出登录吗',
					buttons: ['确定', '取消']
				}, function (ret, err) {
					var index = ret.buttonIndex;
					if (index == 1) {
						$.loading();
						$.request({
							url: "/security/logout",
							successCallBack: function (response) {
								var cid = localStorage.getItem('pushCid');
								var gold_price = localStorage.getItem('gold_price');
								localStorage.clear();
								localStorage.setItem('pushCid', cid);
								localStorage.setItem('gold_price', gold_price);
								$.get('/token', function () {
									api.sendEvent({
										name: 'logoff'
									});
									api.closeWin({
									});
								});
							}
						});
					}
				});
			}
		};
		window.initData = function () {
      user = JSON.parse(localStorage.getItem('user'));

			if (user) {
				var identityCardNo = user.identityCardNo ? ((user.identityCardNo.slice(0, 3)) + '***' + (user.identityCardNo.slice(user.identityCardNo.length - 4, user.identityCardNo.length))) : '';
        $('#nameSpan').text(user.realName || '');
        $('#mobileSpan').text(user.mobile ? (user.mobile.slice(0, 3)) + '***' + (user.mobile.slice(7, 11)) : '');

        if (user.identityCardValidateStatus) {
          $('#identityCardNoSpan').text(identityCardNo);
        } else {
          $('#identityCardNoSpan').html(identityCardNo + '<span style="margin-left: 0.25rem;color: #34acff;" onclick="showWin(this,\'identity\', \'实名认证\')">实名认证</span>');
        }
        if (user.identityCardValidateStatus) {
          $('#identityCardValidateStatusSpan').show();
        }
			}
		};
		main();
	});
})();
