(function () {

	var beecloud = {};
	var channels = [];

	beecloud.payReq = function (data, cbsuccess, cberror) {
		doPay(data, cbsuccess, cberror);
	};

	// beecloud.genBillNo = function() {
	// 	var d = new Date();
	// 	var vYear = d.getFullYear();
	// 	var vMon = d.getMonth() + 1;
	// 	var vDay = d.getDate();
	// 	var h = d.getHours();
	// 	var m = d.getMinutes();
	// 	var se = d.getSeconds();
	// 	var ms = d.getMilliseconds();
	// 	billno = "" + vYear + (vMon < 10 ? "0" + vMon : vMon) + (vDay < 10 ? "0" + vDay : vDay) + (h < 10 ? "0" + h : h) + (m < 10 ? "0" + m : m) + (se < 10 ? "0" + se : se) + ms;
	// 	return billno;
	// };


	function getPayUrl() {
		return config.host + "/pay/apply";
	}

	function doPay(payData, cbsuccess, cberror) {
		$.loading();
		$.post(getPayUrl(), payData, function (data) {
			if (data.code == 500) {
				mui.toast(data.msg);
				return;
			}
			if(payData.payChannel == '4') {
				data.data = JSON.parse(data.data.replace(/\\\"/g, ""));
				document.getElementById('bigMoneyChanelIframe').src = data.data.codeUrl;
			}
			
			if (payData.payChannel == 2) { // 支付宝
				//var aliPay = api.require('aliPay');
				//aliPay.payOrder({
				var aliPayPlus = api.require('aliPayPlus');
				aliPayPlus.payOrder({
					orderInfo: data.data
				}, function (ret, err) {
					if (ret.code == 9000) {
						cbsuccess();
					} else {
						cberror(ret);
					}
				});
			} else if (payData.payChannel == 1) { // 微信
				if (data.data) {
					var wxPay = api.require('wxPay');
					wxPay.payOrder(JSON.parse(data.data),
						function (ret, err) {
							if (ret.status === true) {
								cbsuccess();
							} else {
								//错误码：
								//-2（用户取消，发生场景：用户不支付了，点击取消，返回APP）
								//-1（未知错误，可能的原因：签名错误、未注册APPID、项目设置APPID不正确、注册的APPID与设置的不匹配、其他异常等）
								//1 (apiKey值非法)
								if (err.code == "-2") {
									console.log("用户取消");
								}
								if (err.code == "-1") {
									console.log("未知错误，可能的原因：签名错误、未注册APPID、项目设置APPID不正确、注册的APPID与设置的不匹配、其他异常等");
								}
								if (err.code == "1") {
									console.log("apiKey值非法");
								}
								cberror(ret);
							}
						});
				}
			}
			

		}, 'json');
	}
	window.beecloud = beecloud;
})();
