mui.plusReady(function() {
	var pageSize, pageNo, total, pageNo2, total2;

	_.setDownRefresh(function() {
		pageNo = 1;
		pageSize = 10;
		total = 1;

		pageNo2 = 1;
		pageSize2 = 10;
		total2 = 1;
		queryRecords(function() {
			_.endDownRefresh();
		});
	}).setUpRefresh(function() {
		queryRecords(function(){
			_.endUpRefresh();
		});
	},document.getElementById('content').parentElement);
	 

	var main = function() {
		pageNo = 1;
		pageSize = 10;
		total = 1;
		
		pageNo2 = 1;
		pageSize2 = 10;
		total2 = 1;
		$.loading();
		queryRecords();
	};

	window.bindEvent ={
		productDetail: function (productId) {     	 		   
		   api.openWin({
			   name: 'product_detail_wrapper'+productId,
			   url: 'product_detail_wrapper.html',
			   pageParam:{
				   productId:productId
			   }
		   });
	   }		 			
   };

	function queryRecords(callback) {
		$.request({
			type : "GET",
			url : "/order/purchase/list",
			data : {
				pageSize : pageSize,
				pageNo : pageNo
			},
			successCallBack : function(response) {			
				callback && callback();	 				
				if (response && response.data && response.data.data) {					 
					if (pageNo == 1) {
						$('#content').html($.render($('#recordsTpl').html(), response.data.data));
						if(response.data.data.length == "0") {
							queryProducts();
						}
					} else {
						if(response.data.data.length){
							$('#content').append($.render($('#recordsTpl').html(), response.data.data));	
						}else{
							mui.toast('没有更多了');
							return;
							// _.noMoreData();
						}					
					}
					pageNo++;
					total = response.data.total;
				} else {
					mui.toast('查询失败！');									
				}
			}
		});
	}

	function queryProducts() {
		if (pageNo2 > total2) {
			mui.toast('没有更多了');
			return;
		}

		$.request({
			url : "/index/product/list",
			data : {
				pageSize : pageSize2,
				pageNo : pageNo2
			},
			successCallBack : function(response) {
				if (response && response.data && response.data.data) {
					$('#detailProductsUl').append($.render($('#detailProductsTpl').html(), response.data.data));
					api.parseTapmode();
					total2 = response.data.total;
					pageNo2++;
				} else {
					mui.alert('查询产品信息失败！');
				}
			}
		});
	}
	main();
});
