(function() {
	mui.plusReady(function() {
		var mainForm, orderNo, order;

		var main = function() {
			$.getToken();
			mainForm = $('#mainForm');
			orderNo = getParam('orderNo');
			initData();
			
		};

		var initData = function() {
			$.loading();
			$.post('/order/consume/query', {
				orderNo : orderNo
			}, function(response) {
				if (response.code == 200) {
					order = response.data;
					setOrderDetail(response.data);
				} else {
					mui.toast(response.msg || '获取提货订单详情失败')
				}
			});
		};

		var setOrderDetail = function(data) {
			var content = $.render($('#exchangeDetailTpl').html(), data);
			$('#mainForm .list').html(content);
		};

		window.bindEvent = {
			submit : function() {
				var data = mainForm.getFormJson();
				data.orderNo = orderNo;
				
				$.loading();
				$.request({
					url : "/order/consume/cancel",
					data : data,
					successCallBack : function(response) {
						if (response.code == '200') {
							$.openNewWin('operate_success_wrapper.html?action=cancel_exchange', '取消兑换成功', false);
						} else {
							mui.toast(response.msg || '操作失败');
						}
					},
					onerror:function(response){
						mui.toast(response.msg || '操作失败');
					}
				});
			}
		};
		main();
	});
})();
