mui.plusReady(function() {
	var mainForm1, mainForm2, mobile, intervalId;

	var main = function() {
		mainForm1 = $('#mainForm1');
		mainForm2 = $('#mainForm2');
		$.getToken();
	};

	var countSeconds = function() {
		var count = 60;
		$('#sendCode').text('重新发送(' + (count--) + ')');
		clearInterval(intervalId);
		intervalId = null;
		$('#sendCode').attr('disabled', true);
		intervalId = setInterval(function() {
			if (count == 0) {
				clearInterval(intervalId);
				intervalId = null;
				$('#sendCode').text('重新发送');
				$('#sendCode').removeAttr('disabled');
			} else {
				$('#sendCode').text('重新发送(' + (count--) + ')');
			}
		}, 1000);
	};
	window.bindEvent = {
		sendCode : function() {
			var data = mainForm1.getFormJson();

			if (!$.valiMobile(data.mobile) || $('#sendCode').attr('disabled')) {
				return;
			}
			$('#sendCode').attr('disabled', true);
			$.request({
				url : "/member/complete_info/send_mobile_captcha",
				data : {
					mobile : data.mobile,
					form_token:$('[name="form_token"]').val()
				},
				successCallBack : function(response) {
					if (response.code == "200") {
						mui.alert('验证码已经发送到您的手机' + (data.mobile.slice(0, 3)) + '***' + (data.mobile.slice(7, 11)));
						countSeconds();
					} else {
						mui.alert('发送失败，请重新发送。');
						$('#sendCode').removeAttr('disabled');
					}
				},
				failCallBack : function(textStatus) {
					if (textStatus != 'canceled') {
						mui.alert('发送失败，请重新发送。');
						$('#sendCode').removeAttr('disabled');
					}
				}
			});
			$.getToken();
		},

		mobileCaptcha : function() {//keyup
			if ($('[name="mobileCaptcha"]').val()) {
				$('[role="submit"]').attr('disabled', false);
			} else {
				$('[role="submit"]').attr('disabled', true);
			}
		},

		submit : function() {
			// 获取form数据
			var data = $.extend(mainForm1.getFormJson(), mainForm2.getFormJson());
			if (!$.valiMobile(data.mobile)) {
				return;
			}

			if (!$.valiBlank(data.pwd, "请输入密码")) {
				return;
			}

			if (!$.valiBlank(data.mobileCaptcha, "请输入验证码")) {
				return;
			}

			$.loading();
			// 提交表单
			$.request({
				url : "/member/complete_info",
				data : data,
				onsuccess : function(response, XMLHttpRequest) {
					api.execScript({
						name : 'root',
						frameName : 'frame0',
						script : 'location.href="frame0.html"'
					});
					if (location.href.indexOf('my_login.htm') != -1) {
						api.removeEventListener({
							name : 'viewappear'
						});
						location.href = 'frame1.html';
					} else {
						api.execScript({
							name : 'root',
							frameName : 'frame1',
							script : 'location.href="frame1.html"'
						});
						$.closeToHome();
					}
				},
				onerror : function(response) {
					mui.alert(response.msg || '操作失败');
				}
			});
		}
	};

	$('[name="mobileCaptcha"]').on('keyup', function(e) {
			e.preventDefault();
			if ($('[name="mobileCaptcha"]').val()) {
				$('[role="submit"]').removeAttr('disabled');
			} else {
				$('[role="submit"]').attr('disabled', true);
			}
	});
	main();
});
