(function() {
	mui.plusReady(function() {
		var pageSize, pageNo, isLoading, total, pageNo2, total2;
		_.setDownRefresh(function() {
			pageNo = 1;
			pageSize = 10;
			total = 1;

			pageNo2 = 1;
			pageSize2 = 10;
			total2 = 1;
			queryRecords(function() {
				_.endDownRefresh();
			});
		}).setUpRefresh(function() {
			queryRecords(function() {
				_.endUpRefresh();
			});
		},document.getElementById('content-inner').parentElement);

		var main = function(callback) {
			pageNo = 1;
			pageSize = 10;
			total = 1;

			pageNo2 = 1;
			pageSize2 = 10;
			total2 = 1;
			$.loading();
			queryRecords();
		};

		function queryRecords(callback) {
			$.request({
				type : "GET",
				url : "/order/consume/list",
				data :{
					pageSize : pageSize,
					pageNo : pageNo
				},
				successCallBack : function(response) {
					callback && callback();
					if (response && response.data && response.data.data) {
						
						if (pageNo == 1) {							
							$('#content-inner').html($.render($('#recordsTpl').html(), response.data.data));
							if(response.data.data.length == "0") {
								queryProducts();
							}
						} else {
							if (response.data.data.length) {
								$('#content-inner').append($.render($('#recordsTpl').html(), response.data.data));
							} else {
								mui.toast('没有更多了');
								return;
							}
						}
						api.parseTapmode();
						pageNo++;
						total = response.data.total;
					}
				}
			});
		};

		function queryProducts() {
			if (pageNo2 > total2) {
				mui.toast('没有更多了');
				return;
			}
	
			$.request({
				url : "/index/product/list",
				data : {
					pageSize : pageSize2,
					pageNo : pageNo2
				},
				successCallBack : function(response) {
					if (response && response.data && response.data.data) {
						$('#detailProductsUl').append($.render($('#detailProductsTpl').html(), response.data.data));
						api.parseTapmode();
						total2 = response.data.total;
						pageNo2++;
					} else {
						mui.alert('查询产品信息失败！');
					}
				}
			});
		}

		window.bindEvent = {
			productDetail: function (productId) {     	 		   
				api.openWin({
					name: 'product_detail_wrapper'+productId,
					url: 'product_detail_wrapper.html',
					pageParam:{
						productId:productId
					}
				});
			},		

			role : function(dom) {
				var jq = $(dom);
				var role = jq.attr('role');
				var orderNo = jq.attr('orderNo');
				var consumeGoldWeight = jq.attr('consumeGoldWeight');
				if (role == 'pay') {
					var orderType = jq.attr('orderType');
					var status = jq.attr('status');
					var orderAmount = jq.attr('supplementAmount');
					// 线上提货
					if (orderType == "1") {
						if (status == 11) {// 部分支付
							var slidBackEnabled = true;
							$.request({
								url: "/pay/query_channel",
								data: {
									orderNo: orderNo, 
									deductFlag: '0',
									paymentType: '2'
								},
								successCallBack: function (res) {
									if (res.code == '200') {
										// 大额--打开的支付页面没有右滑功能
										if(res.data == '1') {
											slidBackEnabled = false;
										}
									} else {
										mui.alert(res.msg || '操作失败');
									}
									$.newWin('在线支付', {
										url : 'buy_gold_step2.htm?f=2&data=' + encodeURIComponent(JSON.stringify({
											goldAmount : orderAmount,
											orderNo : orderNo
										})), 
										name : 'buy_gold_step2',
										slidBackEnabled: slidBackEnabled,
									});
								}
							});
							// $.openNewWin('buy_gold_step2.htm?f=2&data=' + encodeURIComponent(JSON.stringify({
							// 	goldAmount : orderAmount,
							// 	orderNo : orderNo
							// })), '在线支付');
						} else {
							$.openNewWin("online_exchange_step1.htm?orderNo=" + orderNo, '线上提货');
						}
						// 门店提货
					} else if (orderType == "2") {
						$.openNewWin("shop_exchange_step1.htm?orderNo=" + orderNo, '门店提货');
					
					// 扫码兑换
					} else if(orderType == "3") {
						// 待支付状态
						if(status == "10") {
							$.openNewWin("buy_gold_and_exchange_from_records.htm?orderNo=" + orderNo, '扫码兑换');

						// 部分支付状态
						}else if(status == "11" || status == "12") {
							var deductFlag = (consumeGoldWeight > 0) ? "1" : "0";
							// $.openNewWin('buy_gold_step2.htm?f=3&data=' + encodeURIComponent(JSON.stringify({
							// 	goldAmount : orderAmount,
							// 	orderNo : orderNo,
							// 	deductFlag: deductFlag
							// })), '在线支付');

							var slidBackEnabled = true;
							$.request({
								url: "/pay/query_channel",
								data: {
									orderNo: orderNo, 
									deductFlag: deductFlag,
									paymentType: '5'
								},
								successCallBack: function (res) {
									if (res.code == '200') {
										// 大额--打开的支付页面没有右滑功能
										if(res.data == '1') {
											slidBackEnabled = false;
										}
									} else {
										mui.alert(res.msg || '操作失败');
									}
									$.newWin('在线支付', {
										url : 'buy_gold_step2.htm?f=3&data=' + encodeURIComponent(JSON.stringify({
											goldAmount : orderAmount,
											orderNo : orderNo,
											deductFlag: deductFlag
										})), 
										name : 'buy_gold_step2',
										slidBackEnabled: slidBackEnabled,
									});
								}
							});
						}
					}
				} else if (role == 'cancel') {
					var orderType = jq.attr('orderType');
					console.log("orderType==="+jq.attr('orderType'));
					// 扫码兑换
					if(orderType == "3") {
						$.openNewWin("buy_gold_and_exchange_from_records_cancel.htm?orderNo=" + orderNo, '取消兑换');

					// 其他
					}else {
						$.openNewWin("cancel_exchange.htm?orderNo=" + orderNo, '取消兑换');
					}
				}

			}
		};
		main();
	});
})();
