(function() {
	mui.plusReady(function() {
		var mainForm, mobile, intervalId;

		var main = function() {
			mainForm = $('#mainForm');
			$.getToken();
			mobile = getParam('mobile');
		};

		var countSeconds = function() {
			var count = 60;
			$('#sendCode').text('重新发送(' + (count--) + ')');
			clearInterval(intervalId);
			intervalId = null;
			$('#sendCode').attr('disabled', true);

			intervalId = setInterval(function() {
				if (count == 0) {
					clearInterval(intervalId);
					intervalId = null;
					$('#sendCode').text('重新发送');
					$('#sendCode').removeAttr('disabled', false);
				} else {
					$('#sendCode').text('重新发送(' + (count--) + ')');
				}
			}, 1000);
		};
		window.bindEvent = {
			sendCode : function() {
				var data = mainForm.getFormJson();
				if ($('#sendCode').attr('disabled')) {
					return;
				}
				$('#sendCode').attr('disabled', true);
				$.request({
					url : "/security/send_mobile_captcha",
					data : {
						mobile : mobile,
						form_token:$('[name="form_token"]').val()
					},
					successCallBack : function(response) {
						if (response.code == "200") {
							mui.alert('验证码已经发送到您的手机' + (mobile.slice(0, 3)) + '***' + (mobile.slice(7, 11)));
							countSeconds();
						} else {
							mui.alert(response.msg || '发送失败，请重新发送。');
							$('#sendCode').removeAttr('disabled');
						}
					},
					failCallBack : function(textStatus) {
						if (textStatus != 'canceled') {
							mui.alert('发送失败，请重新发送。');
							$('#sendCode').removeAttr('disabled');
						}
					}
				});
				$.getToken();
			},
			submit : function() {
				var data = $.extend(mainForm.getFormJson(), {
					mobile : mobile
				});
				document.activeElement.blur();
				$.loading();
				// 关闭计时器
				$.request({
					url : "/security/pwd_reset/step2",
					data : data,
					successCallBack : function(response) {
						$.openNewWin('find_pwd_step3.htm?mobile=' + data.mobile, '找回密码');
					}
				});
			}
		};

		$('[name="mobileCaptcha"]').on('keyup', function(e) {
			e.preventDefault();
			if ($('[name="mobileCaptcha"]').val()) {
				$('[role="submit"]').removeAttr('disabled');
			} else {
				$('[role="submit"]').attr('disabled', true);
			}
		});

		main();
	});
})();
