
mui.plusReady(function() {

	function closeGuide() {
		api.execScript({
			name: 'root',
			frameName: 'guide',
			script: 'close()'
		});
	};
	if (location.href.indexOf('my_login') != -1) {
		$api.fixStatusBar($api.dom('header'));
		api.setStatusBarStyle({
			style : 'dark',
			color : '#3379b5'
		});
	}
	_.endDownRefresh();
	api.setRefreshHeaderInfo({
		visible:false
  });

	var mainForm, token, type, flag = false, captchaUrl;

	captchaUrl = config.host;
	var main = function() {
		mainForm = $('#mainForm');
		type = getParam('t') || '';
		api.setRefreshHeaderInfo({
			visible : false
		}, function(ret, err) {			//coding...
		});
		showThirdLogin();
	};

	function showThirdLogin() {
		if(api.systemType.toLowerCase() == 'ios') {
			var wx = api.require('wx');
			wx.isInstalled(function(ret, err) {if (ret.installed) {
				$('#weixin_div').show();
				$('#weixin_div').parent().show();
				$('.Landing-mode').show();
			}});

			var qq = api.require('qq');
			qq.installed(function(ret, err) {if (ret.status) {
				$('#qq_div').show();
				$('#qq_div').parent().show();
				$('.Landing-mode').show();
			}});

			var weibo = api.require('weibo');
			weibo.isInstalled(function(ret, err) {if (ret.status) {
				$('#weibo_div').show();
				$('#weibo_div').parent().show();
				$('.Landing-mode').show();
			}});
		}else {
			$('#weixin_div').show();
			$('#weixin_div').parent().show();
			$('#qq_div').show();
			$('#qq_div').parent().show();
			$('#weibo_div').show();
			$('#weibo_div').parent().show();
			$('.Landing-mode').show();
		}
	}

	var bindGeTui = function(callback) {

		$.request({
			type : "POST",
			url : "/member/bind_push_cid",
			data: {cid: localStorage.getItem('pushCid')},
			onsuccess : function(response) {
				localStorage.setItem('is_logined', '1');
				var user = response.data;
				if (user) {
					localStorage.setItem('user', JSON.stringify(response.data));
					callback();
				}
			}
		});

	};



	var ajpush = api.require('ajpush');
	window.bindEvent = {
		captchaImg : function(dom,callback) {
			document.getElementById('captchaImg').setAttribute('src', captchaUrl+'/simpleCaptcha.png?_='+new Date().getTime());
			// if (!dom) {
			// 	dom = document.getElementById('captchaImg');
			// }
			// $.setValidImgCode(dom,callback);
		},

		wxLogin: function() {
			if(flag) {
				return;
			}
			flag = true;
			var wx = api.require('wx');
			wx.isInstalled(function(ret, err) {
				if (ret.installed) {
					$.loading();
					$.request({
						url: "/auth_login/param/query",
						data: {
							platform: "weixin"
						},
						successCallBack: function(ret) {
							setTimeout(function() {$.loading();}, 100);

							// 这里往下就调用没反应了，ret.data.appId确认有值，而且值是对的
							wx.auth({
								apiKey: ret.data.appId
							}, function(ret, err) {
								$.unloading();
								if (ret.status) {
									$.request({
										url: "/auth_login/callback",
										data: {
											platform: "weixin",
											code: ret.code
										},
										successCallBack: function(ret) {
											ajpush.getRegistrationId(function(reg) {
												var cid = reg.id;
												localStorage.setItem('pushCid', cid);
												$.request({
													type : "POST",
													url : "/member/bind_push_cid",
													data: {cid: cid, cidBindType: 'weixin'},
													onsuccess : function(response) {
														localStorage.setItem('is_logined', '1');
														// 跳转到让客户关联用户或者完善信息页面
														if(ret.data == "0") {
															api.execScript({
																	name: 'root',
																frameName: 'frmName1',
																script: '$.complete_user_action = "0";'
															});
															localStorage.setItem('is_logined', '1');

															if (location.href.indexOf('my_login.htm') != -1) {
																api.removeEventListener({
																	name : 'viewappear'
																});
																location.href = 'frame1.html';
																// $.openNewWin('choose_third_login_action.htm?action=all', '成为金持会员');
																$.newWin('成为金持会员', {
																	url : 'choose_third_login_action.htm?action=all', 
																	name : 'choose_third_login_action',
																	slidBackEnabled: false,
																});
															} else {

																api.execScript({
																	name : 'root',
																	frameName : 'frame1',
																	script : 'removeViewAppear();location.href="frame1.html"'
																});
																if (type == 1) {
																	$.closeToHome();
																	return;
																}
																api.closeWin({
																});
																// $.openNewWin('choose_third_login_action.htm?action=all', '成为金持会员');
																$.newWin('成为金持会员', {
																	url : 'choose_third_login_action.htm?action=all', 
																	name : 'choose_third_login_action',
																	slidBackEnabled: false,
																});
															}

														// 直接跳转到登录成功页面
														}else if(ret.data == "1") {
															localStorage.setItem('is_logined', '1');
															if (location.href.indexOf('my_login.htm') != -1) {
																api.removeEventListener({
																	name : 'viewappear'
																});
																location.href = 'frame1.html';
															} else {
																api.execScript({
																	name : 'root',
																	frameName : 'frame1',
																	script : 'removeViewAppear();location.href="frame1.html"'
																});
																// if (type == 1) {
																	$.closeToHome();
																	return;
																// }
																// api.closeWin({
																// });
															}
														}
													}
												});
											});
											closeGuide();
										},
										failCallBack: function (ret) {
											if (ret && ret.msg) {
												mui.alert(ret.msg)
											}
											flag = false;
										}
									});
								} else {
									//数字类型；
	                //错误码：
	                //-1（未知错误），
	                //0（成功，用户同意）
	                //1 (用户取消)
	                //2 (用户拒绝授权)
	                //3 (当前设备未安装微信客户端)
									flag = false;
									if(err.code == "-1") {
										mui.toast("系统错误");
									}else if(err.code == "3") {
										mui.toast("您的手机上没有安装微信，请先安装微信");
									}
									$.unloading();
								}
							});
						},
						failCallBack: function (ret) {
							if (ret && ret.msg) {
								mui.alert(ret.msg)
							}
							flag = false;
						}
					});
				} else {
					flag = false;
					alert('当前设备未安装微信客户端');
				}
			});
		},

		qqLogin: function() {
			if(flag) {
				return;
			}
			flag = true;
			var qq = api.require('qq');
			qq.installed(function(ret, err) {
				if (ret.status) {
					$.loading();
					$.request({
						url: "/auth_login/param/query",
						data: {
							platform: "qq"
						},
						successCallBack: function(ret) {
							setTimeout(function() {$.loading();}, 100);

							// 这里往下就调用没反应了，ret.data.appId确认有值，而且值是对的---如果从后台拿appId  IOS设备登录有问题，所以只能从配置上面拿然后直接登录
							// qq.login({
							// 	apiKey: ret.data.appId
							// }, function(ret, err) {
							qq.login(function(ret, err) {
								$.unloading();
								if (ret.status) {
									$.request({
										url: "/auth_login/callback",
										data: {
											platform: "qq",
											code: ret.accessToken
										},
										successCallBack: function(ret) {
											ajpush.getRegistrationId(function(reg) {
												var cid = reg.id;
												localStorage.setItem('pushCid', cid);
												$.request({
													type : "POST",
													url : "/member/bind_push_cid",
													data: {cid: cid, cidBindType: 'qq'},
													onsuccess : function(response) {
														localStorage.setItem('is_logined', '1');
														// 跳转到让客户关联用户或者完善信息页面
														if(ret.data == "0") {
															api.execScript({
																	name: 'root',
																frameName: 'frmName1',
																script: '$.complete_user_action = "0";'
															});
															localStorage.setItem('is_logined', '1');

															if (location.href.indexOf('my_login.htm') != -1) {
																api.removeEventListener({
																	name : 'viewappear'
																});
																location.href = 'frame1.html';
																// $.openNewWin('choose_third_login_action.htm?action=all', '成为金持会员');
																$.newWin('成为金持会员', {
																	url : 'choose_third_login_action.htm?action=all', 
																	name : 'choose_third_login_action',
																	slidBackEnabled: false,
																});
															} else {
																api.execScript({
																	name : 'root',
																	frameName : 'frame1',
																	script : 'removeViewAppear();location.href="frame1.html"'
																});
																if (type == 1) {
																	$.closeToHome();
																	return;
																}
																api.closeWin({
																});
																// $.openNewWin('choose_third_login_action.htm?action=all', '成为金持会员');
																$.newWin('成为金持会员', {
																	url : 'choose_third_login_action.htm?action=all', 
																	name : 'choose_third_login_action',
																	slidBackEnabled: false,
																});
															}

														// 直接跳转到登录成功页面
														}else if(ret.data == "1") {
															localStorage.setItem('is_logined', '1');
															if (location.href.indexOf('my_login.htm') != -1) {
																api.removeEventListener({
																	name : 'viewappear'
																});
																location.href = 'frame1.html';
															} else {
																api.execScript({
																	name : 'root',
																	frameName : 'frame1',
																	script : 'removeViewAppear();location.href="frame1.html"'
																});
																// if (type == 1) {
																	$.closeToHome();
																	return;
																// }
																// api.closeWin({
																// });
															}
														}
													}
												});
											});
											closeGuide();
										},
										failCallBack: function (ret) {
											if (ret && ret.msg) {
												mui.alert(ret.msg)
											}
											flag = false;
										}
									});
								} else {
									flag = false;
									mui.toast(err.msg || "系统错误")
								}
							});
						},
						failCallBack: function (ret) {
							if (ret && ret.msg) {
								mui.alert(ret.msg)
							}
							flag = false;
						}
					});
				} else {
					flag = false;
					alert('当前设备未安装QQ');
					$.unloading();
				}
			});
		},

		weiboLogin: function() {
			if(flag) {
				return;
			}
			flag = true;
			var weibo = api.require('weibo');
			weibo.isInstalled(function(ret, err) {
				if (ret.status) {
					$.loading();
					$.request({
						url: "/auth_login/param/query",
						data: {
							platform: "sinaweibo"
						},
						successCallBack: function(ret) {
							setTimeout(function() {$.loading();}, 100);

							// 这里往下就调用没反应了，ret.data.appId确认有值，而且值是对的---如果从后台拿appId  IOS设备登录有问题，所以只能从配置上面拿然后直接登录
							// qq.login({
							// 	apiKey: ret.data.appId
							// }, function(ret, err) {
							weibo.auth(function(ret, err) {
								$.unloading();
								if (ret.status) {
									$.request({
										url: "/auth_login/callback",
										data: {
											platform: "sinaweibo",
											code: ret.userId
										},
										successCallBack: function(ret) {
											ajpush.getRegistrationId(function(reg) {
												var cid = reg.id;
												localStorage.setItem('pushCid', cid);
												$.request({
													type : "POST",
													url : "/member/bind_push_cid",
													data: {cid: cid, cidBindType: 'sinaweibo'},
													onsuccess : function(response) {
														localStorage.setItem('is_logined', '1');
														// 跳转到让客户关联用户或者完善信息页面
														if(ret.data == "0") {
															api.execScript({
																	name: 'root',
																frameName: 'frmName1',
																script: '$.complete_user_action = "0";'
															});
															localStorage.setItem('is_logined', '1');

															if (location.href.indexOf('my_login.htm') != -1) {
																api.removeEventListener({
																	name : 'viewappear'
																});
																location.href = 'frame1.html';
																// $.openNewWin('choose_third_login_action.htm?action=all', '成为金持会员');
																$.newWin('成为金持会员', {
																	url : 'choose_third_login_action.htm?action=all', 
																	name : 'choose_third_login_action',
																	slidBackEnabled: false,
																});
															} else {

																api.execScript({
																	name : 'root',
																	frameName : 'frame1',
																	script : 'removeViewAppear();location.href="frame1.html"'
																});
																if (type == 1) {
																	$.closeToHome();
																	return;
																}
																api.closeWin({
																});
																// $.openNewWin('choose_third_login_action.htm?action=all', '成为金持会员');
																$.newWin('成为金持会员', {
																	url : 'choose_third_login_action.htm?action=all', 
																	name : 'choose_third_login_action',
																	slidBackEnabled: false,
																});
															}

														// 直接跳转到登录成功页面
														}else if(ret.data == "1") {
															localStorage.setItem('is_logined', '1');
															if (location.href.indexOf('my_login.htm') != -1) {
																api.removeEventListener({
																	name : 'viewappear'
																});
																location.href = 'frame1.html';
															} else {
																api.execScript({
																	name : 'root',
																	frameName : 'frame1',
																	script : 'removeViewAppear();location.href="frame1.html"'
																});
																// if (type == 1) {
																	$.closeToHome();
																	return;
																// }
																// api.closeWin({
																// });
															}
														}
													}
												});
											});
											closeGuide();
										},
										failCallBack: function (ret) {
											if (ret && ret.msg) {
												mui.alert(ret.msg)
											}
											flag = false;
										}
									});
								} else {
									flag = false;
									mui.toast(err.msg || "系统错误")
								}
							});
						},
						failCallBack: function (ret) {
							if (ret && ret.msg) {
								mui.alert(ret.msg)
							}
							flag = false;
						}
					});
				} else {
					flag = false;
					alert('当前设备未安装新浪微博');
					$.unloading();
				}
			});
		},

		submit : function(e) {
			var data = mainForm.getFormJson();
			var _this = this;
			if (!$.valiAccount(data.loginName)) {
				return;
			}
			if (!$.valiBlank(data.pwd, "请输入密码")) {
				return;
			}
			if(document.getElementById('captchaDiv').style.display != 'none') {
				if (!$.valiBlank(data.captcha, "请输入验证码")) {
					return;
				}
			}
			$.loading();
			$.request({
				url : "/security/member/login",
				data : data,
				onsuccess : function(response, XMLHttpRequest) {
					ajpush.getRegistrationId(function(reg) {
						var cid = reg.id;
						localStorage.setItem('pushCid', cid);
						$.request({
							type : "POST",
							url : "/member/bind_push_cid",
							data: {cid: cid, cidBindType: 'default'},
							onsuccess : function(response) {
								localStorage.setItem('is_logined', '1');

								if (location.href.indexOf('my_login.htm') != -1) {
									api.removeEventListener({
										name : 'viewappear'
									});
									location.href = 'frame1.html';
								} else {
									type = getParam('t') || '';
									api.execScript({
										name : 'root',
										frameName : 'frame1',
										script : 'removeViewAppear();location.href="frame1.html"'
									});
									// if (type == 1) {
										$.closeToHome();
										return;
									// }
									// api.closeWin({
									// });
								}
							}
						});
					});
					closeGuide();
				},
				onerror : function(response) {
					if(response && response.msg.indexOf('#') != -1) {
						if(response.msg.split('#')[1] >= 3) {
							showCaptcha();
						}
						response.msg = response.msg.split('#')[0];

					}else if(response && response.msg.indexOf('请填写验证码') != -1) {
						showCaptcha();
					}
					mui.alert(response.msg || '操作失败');
					bindEvent.captchaImg();

				}
			});
		}
	};

	var showCaptcha = function() {
		document.getElementById('captchaDiv').style.display = 'block';
		document.getElementById('captchaImg').style.visibility = 'visible';
		window.bindEvent.captchaImg();
	}

	window.removeViewAppear = function() {
		api.removeEventListener({
			name : 'viewappear'
		});
	};
	api.addEventListener({
		name : 'viewappear'
	}, function(ret, err) {
		var is_logined = localStorage.getItem('is_logined');
		if (!is_logined) {
			// bindEvent.captchaImg();
		}
	});

	api.addEventListener({
		name : 'viewappear'
	}, function(ret, err) {
		var is_logined = localStorage.getItem('is_logined');
		if (!is_logined) {
			// bindEvent.captchaImg();
		}
	});
	main();
});
