(function() {
	var receiverAddress = '';
	mui.plusReady(function() {
		var mainForm, orderNo, order,supplementStatus;
		var main = function() {
			mainForm = $('#mainForm');
			orderNo = getParam('orderNo');
			initData();
			$.request({
				type: "GET",
				loading: "0",
				url: "/member/query",
				onsuccess: function(response) {
					localStorage.setItem('is_logined', 1);
					var user = response.data;
					if(user) {
						localStorage.setItem('user', JSON.stringify(response.data));
						$('#receiverName').val(user.realName);
						if(user.completeFlag == "0") {
							setTimeout(function() {
								// $.openNewWin('choose_third_login_action.htm?winName=p_online_exchange_step1', '成为金持会员');
								$.newWin('成为金持会员', {
									url : 'choose_third_login_action.htm?action=all', 
									name : 'choose_third_login_action',
									slidBackEnabled: false,
								});
							}, 500);
//							$.openNewWin('choose_third_login_action.htm?winName=p_online_exchange_step1', '成为金持会员');
							// api.closeWin({
							// 	name: 'p_online_exchange_step1'
							// });
							return;
						}
					}
				},
				onerror: function() {
				}
			});
		};

		var initData = function() {
			$.loading();
			$.request({
				url: "/order/consume/query",
				data: {
					orderNo: orderNo
				},
				successCallBack: function(response) {
					order = response.data;
					setOrderDetail(response.data);
					supplementStatus = response.data.supplementStatus;
					var headerHeight = api.pageParam.headerHeight;
					var UIActionSelector = api.require('UIActionSelector');
					$('#citySelect').click(function() {
						UIActionSelector.open({
							datas: 'widget://resources/cityList.json',
							layout: {
								row: 5,
								col: 3,
								height: 30,
								size: 12,
								sizeActive: 14,
								rowSpacing: 5,
								colSpacing: 10,
								maskBg: 'rgba(0,0,0,0.2)',
								bg: '#fff',
								color: '#888',
								colorActive: '#ff8001',
								colorSelected: '#ff8001'
							},
							animation: true,
							cancel: {
								text: '取消',
								size: 12,
								w: 90,
								h: 35,
								bg: '#fff',
								bgActive: '#ccc',
								color: '#888',
								colorActive: '#fff'
							},
							ok: {
								text: '确定',
								size: 12,
								w: 90,
								h: 35,
								bg: '#fff',
								bgActive: '#ccc',
								color: '#888',
								colorActive: '#fff'
							},
							title: {
								text: '请选择',
								size: 12,
								h: 44,
								bg: '#eee',
								color: '#888'
							},
							fixedOn: api.frameName
						}, function (ret, err) {
							if (ret && ret.eventType === 'ok') {
								var address = [];
								var province;
								var city;
								var area;
								province = ret.level1;
								city = ret.level2;
								area = ret.level3;
								address.push(province);
								address.push(city);
								if (area) {
									address.push(area);
								}
								receiverAddress = address.join('/');
								$("#citySelect").html(receiverAddress || '请选择省市区');
							}
						});
					});
				}
			});
		};

		var setOrderDetail = function(data) {
			var content = $.render($('#exchangeDetailTpl').html(), data);
			$('#mainForm .list').html(content);
			var receiverAddress = (order.receiverAddress || '').split(' ');
			var area = receiverAddress.shift();
			$("#citySelect").html(area || '请选择省市区');
			receiverAddress = receiverAddress.join(' ');
			$('#receiverAddress').val(receiverAddress||'');
		};
		window.bindEvent = {
			agree : function(dom) {
				var obj = $(dom);
				if (obj.is('.checked')) {
					obj.removeClass('checked').addClass('unchecked');
					$('#submit').attr('disabled', true);
				} else {
					obj.removeClass('unchecked').addClass('checked');
					$('#submit').removeAttr('disabled');
				}
			},
			submit:function(){
				var data = mainForm.getFormJson();
				if(!$.valiBlank(data.receiverAddress, "请输入收货地址")) {
					return;
				}
				data.receiverAddress = receiverAddress + ' ' + data.receiverAddress;
				data.orderNo = orderNo;
				$.loading();
				$.request({
					url: "/order/online_consume/fill_receive",
					data: data,
					successCallBack: function(response) {
						$.openNewWin('online_exchange_step2.htm?supplementStatus='+ supplementStatus +'&orderNo=' + orderNo, '线上提货');
					}
				});
			}
		};
		main();
	});
})();
