
mui.plusReady(function() {
	var mainForm, data, intervalId;
	data = JSON.parse(decodeURIComponent(getParam('data')));
	var main = function() {
		mainForm = $('#mainForm');
		$.getToken();		 
		setOrderDetail(data);		
	};

	var setOrderDetail = function(data) {
		var content = $.render($('#redeemProductlTpl').html(), data);
		$('[name="form_token"]').after(content);
	};

	var countSeconds = function() {
		var count = 60;
		$('#sendCode').text('重新发送(' + (count--) + ')');
		clearInterval(intervalId);
		intervalId = null;
		intervalId = setInterval(function() {
			if (count == 0) {
				clearInterval(intervalId);
				intervalId = null;
				$('#sendCode').text('重新发送');
				$('#sendCode').removeAttr('disabled');
			} else {
				$('#sendCode').text('重新发送(' + (count--) + ')');
			}
		}, 1000);
	};
	window.bindEvent = {
		sendCode:function(dom){
			if ($('#sendCode').attr('disabled')) {
				return;
			}
			$(dom).attr('disabled', true);
			$.request({
				url : "/security/send_mobile_captcha",
				data : {
					mobile : data.mobile,
					form_token:$('[name="form_token"]').val()
				},
				successCallBack : function(response) {
					if (response.code == "200") {
						mui.alert('验证码已经发送到您的手机' + (data.mobile.slice(0, 3)) + '***' + (data.mobile.slice(7, 11)));
						countSeconds();
					} else {
						mui.alert(response.msg || '发送失败，请重新发送。');
						$('#sendCode').removeAttr('disabled');
					}
				},
				onerror : function(response) {
					mui.alert(response.msg || '发送失败，请重新发送。');
//						$('#sendCode').attr('disabled', false);
					$('#sendCode').removeAttr('disabled');
				}
			});
			$.getToken();
		},
		submit:function(){
			var data = mainForm.getFormJson();
			if (!$.valiBlank(data.mobileCaptcha, "请输入验证码")) {
				return;
			}
			document.activeElement.blur();
			$.loading();

			$.request({
				url : "/recovery_order/add",
				data : data,
				autoCloseWaiting : false,
				successCallBack : function(response) {
          if(response.code == '200') {
            $.openNewWin('operate_success_wrapper.html?action=redeem_product', '旧金回收预约成功', false);
          }else {
            mui.alert(response.msg || '提交失败');
          }
				},
				onerror : function(response) {
					mui.alert(response.msg || '提交失败');
					$('#sendCode').removeAttr('disabled');
					$('#sendCode').text('重新发送');
					if (intervalId) {
						clearInterval(intervalId);
						intervalId = null;
					}
				}
			});
		}
	};
		
	$('[name="mobileCaptcha"]').on('keyup', function(e) {
		e.preventDefault();
		if ($('[name="mobileCaptcha"]').val()) {
			$('[role="submit"]').removeAttr('disabled');
		} else {
			$('[role="submit"]').attr('disabled', true);
		}
	});

	main();
});
