(function() {
	mui.plusReady(function() {
		var mainForm, mobile, intervalId, user, orderNo;

		var main = function() {
			mainForm = $('#mainForm');
			$.getToken();
			orderNo = getParam('orderNo');
			mobile = JSON.parse(localStorage.getItem("user")).mobile;

		};

		var countSeconds = function() {
			var count = 60;
			$('#sendCode').text('重新发送(' + (count--) + ')');
			if (intervalId) {
				clearInterval(intervalId);
				intervalId = null;
			}

			intervalId = setInterval(function() {
				if (count == 0) {
					if (intervalId) {
						clearInterval(intervalId);
						intervalId = null;
					}
					$('#sendCode').text('重新发送');
					$('#sendCode').removeAttr('disabled');
				} else {
					$('#sendCode').text('重新发送(' + (count--) + ')');
				}
			}, 1000);
		};
		window.bindEvent = {
			sendCode : function(dom) {
				if ($('#sendCode').attr('disabled')) {
					return;
				}
				$('#sendCode').attr('disabled', true);
				$.request({
					url : "/security/send_mobile_captcha",
					data : {
						mobile : mobile,
						form_token:$('[name="form_token"]').val()
					},
					successCallBack : function(response) {
						if (response.code == "200") {
							mui.alert('验证码已经发送到您的手机' + (mobile.slice(0, 3)) + '***' + (mobile.slice(7, 11)));
							countSeconds();
						} else {
							mui.alert(response.msg || '发送失败，请重新发送。');
							$('#sendCode').removeAttr('disabled');
						}
					},
					onerror : function(response) {
						mui.alert(response.msg || '发送失败，请重新发送。');
						$('#sendCode').removeAttr('disabled');
					}
				});
				$.getToken();
			},
			submit : function() {
				if (!$('#password').val().trim()) {
					mui.toast("支付密码不能为空");
					return;
				}
				if (!$('#captcha').val().trim()) {
					mui.toast("验证码不能为空");
					return;
				}
				document.activeElement.blur();
				var data = $.extend(mainForm.getFormJson(), {
					mobile : mobile,
					orderNo : orderNo
				});

				$.loading();
				$.request({
					url : "/order/redeem/pay",
					data : data,
					successCallBack : function() {
						$.openNewWin('operate_success_wrapper.html?action=redeem', '回收成功', false);
					}
				});
			}
		};

		$.request({
			url : '/member/validate_pay_pwd',
			type : 'post',
			onsuccess : function(res) {
				if (res.data == 1) {
					//					$.openNewWin('set_pay_pwd.htm','设置支付密码');
				} else {
					var btnArray = ['不设置了', '好'];
					api.confirm({
						title : '提示',
						msg : '您没有设置支付密码，是否去设置支付密码？',
						buttons : btnArray
					}, function(ret, err) {
						var index = ret.buttonIndex;
						if(index == 2){
							$.openNewWin('set_pay_pwd.htm?f='+ api.winName, '设置支付密码');
						}
					});
					 
				}
			},
			onerror : function(res) {
				console.log(JSON.stringify(res));
			}
		});

		$('[name="mobileCaptcha"]').on('keyup', function(e) {
			e.preventDefault();
			if ($('[name="mobileCaptcha"]').val()) {
				$('[role="submit"]').removeAttr('disabled');
			} else {
				$('[role="submit"]').attr('disabled', true);
			}
		});
		main();
	});
})();
