mui.plusReady(function() {
	var mainForm, captchaUrl;

	captchaUrl = config.host;

	var main = function() {
		document.getElementById('captchaImg').style.visibility = 'visible';
		mainForm = $('#mainForm');
		window.bindEvent.captchaImg();
	};
	window.bindEvent = {
		captchaImg : function(dom,callback) {
			document.getElementById('captchaImg').setAttribute('src', captchaUrl+'/simpleCaptcha.png?_='+new Date().getTime());
		},
		agree : function(dom) {
			if (dom.checked) {
				$('#submit').removeAttr('disabled');
			} else {
				$('#submit').attr('disabled', true);
			}
		},
		register_agreement : function() {
			$.openNewWin('register_agreement.htm', '金持用户协议');
		},
		submit : function() {
			var data = mainForm.getFormJson();

			if (!$.valiMobile(data.mobile)) {
				return;
			}
			if (!$.valiLoginPwd(data.password)) {
				return;
			}
			if (!$.valiBlank(data.password_confirm, "请再次确认密码")) {
				return;
			}
			if (data.password != data.password_confirm) {
				mui.toast("您输入的两次密码不一致");
				return;
			}
			if (!$.valiBlank(data.captcha, "请输入验证码")) {
				return;
			}
			$.loading();
			$.request({
				url : "/security/register/step1",
				data : data,
				successCallBack : function(response) {
					$.openNewWin('register_step2.htm?mobile=' + data.mobile, '验证码');
				},
				onerror : function(response) {
					mui.alert(response.msg || '操作失败', function() {
						$('[name="captcha"]').val('');
						bindEvent.captchaImg();
					});
				}
			});
		}
	};

	main();

});
