(function() {
	mui.plusReady(function() {
		var mainForm, orderNo, order;

		var main = function() {

			mainForm = $('#mainForm');
			orderNo = getParam('orderNo');
			initData();

		};

		var initData = function() {
			$.loading();
			$.request({
				url : "/order/consume/query",
				data : {
					orderNo : orderNo
				},
				successCallBack : function(response) {
					order = response.data;
					setOrderDetail(response.data);
				}
			});
		};

		var setOrderDetail = function(data) {
			var content = $.render($('#exchangeDetailTpl').html(), data);

			$('#mainForm .list').html(content);
		};
		window.bindEvent = {
			agree : function(dom) {
				var obj = $(dom);
				if (obj.is('.checked')) {
					obj.removeClass('checked').addClass('unchecked');
					$('#submit').attr('disabled', true);
				} else {
					obj.removeClass('unchecked').addClass('checked');
					$('#submit').removeAttr('disabled');
				}
			},
			submit : function() {				
				$.openNewWin('shop_exchange_step2.htm?orderNo=' + orderNo, '门店提货');
			}
		};

		main();
	});
})();
